#include "opencv2/opencv.hpp"

int main()
{
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("output", cv::WINDOW_AUTOSIZE);
    cv::VideoCapture cap(0);
    cv::Mat input, output;

    cv::Mat weight = (cv::Mat_<float>(3,3) << 
                      0, 1, 0,
                      1, 4, 1,
                      0, 1, 0);
    weight = weight / 8.0f;

    while (1) {
        cap >> input;
        cv::cvtColor(input, input, CV_BGR2GRAY);

        cv::filter2D(input, output, CV_8U, weight);

        cv::imshow("input", input);
        cv::imshow("output", output);
        if (cv::waitKey(30) > 0) {
            break;
        }
    }

    return 0;
}
