#include "opencv2/opencv.hpp"

uchar saturate(int val) {
    if (val > 255) {
        return 255;
    } else if (val < 0) {
        return 0;
    } else {
        return val;
    }
}

int main()
{
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("output", cv::WINDOW_AUTOSIZE);
    cv::VideoCapture cap(0);
    cv::Mat input;
    cap >> input;
    cv::Mat output(input.rows, input.cols, CV_8U);


    cv::Mat weight = (cv::Mat_<int>(3,3) << 
                      0, 1, 0, 
                      1, 4, 1, 
                      0, 1, 0);
    int normalizer = 8;

    while (1) {
        cap >> input;
        cv::cvtColor(input, input, CV_BGR2GRAY);

        for (int j = 1; j < input.rows - 1; j++) {
            for (int i = 1; i < input.cols - 1; i++) {
                int sum = 0;
                for (int n = 0; n < 3; n++) {
                    for (int m = 0; m < 3; m++) {
                        sum += weight.at<int>(n, m)
                            * input.at<uchar>(j - 1 + n, i - 1 + m);
                    }
                }
                output.at<uchar>(j, i) = saturate(sum / normalizer);
            }
        }

        cv::imshow("input", input);
        cv::imshow("output", output);
        if (cv::waitKey(30) > 0) {
            break;
        }
    }

    return 0;
}
